import { Capi } from '@tencent-sdk/capi';
import { ActionType } from './apis';
import { Credentials, MonitorOptions, GetMonitorDataOptions, MonitorData, FormatedMonitorData } from '../typings';
export declare class Monitor {
    credentials: Credentials;
    capi: Capi;
    region: string;
    constructor({ secretId, secretKey, token, region, debug, }: MonitorOptions);
    /**
     * 获取监控数据
     * @param {GetMonitorDataOptions} options 参数
     * @returns
     */
    get(options: GetMonitorDataOptions): Promise<FormatedMonitorData[] | MonitorData[]>;
    request({ Action, ...data }: {
        Action: ActionType;
        [key: string]: any;
    }): Promise<any>;
}
//# sourceMappingURL=index.d.ts.map